package config

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/zrpc"
	"trasfer_middleware/cmd/rpc/etc"
	marketTypes "trasfer_middleware/cmd/rpc/internal/logic/po/market/types"
	rsTypes "trasfer_middleware/cmd/rpc/internal/logic/po/rs/types"
	zltxTypes "trasfer_middleware/cmd/rpc/internal/logic/po/zltx/types"
)

type Config struct {
	zrpc.RpcServerConf
	etc.ExtraConfig
	Cache  cache.CacheConf
	ZLTX   zltxTypes.ZLTXConf
	Market marketTypes.MarketConf
	RS     rsTypes.RSConf
	DB     struct {
		Master struct {
			DataSource string
		}
		Slave struct {
			DataSource string
		}
	}
}
