package po

import (
	"encoding/json"
	"time"
	"trasfer_middleware/cmd/rpc/etc"
	"trasfer_middleware/genModel"
	"trasfer_middleware/until/common"
	"trasfer_middleware/until/request"
)

type RequestStruct struct {
	RequestBody map[string]string
	Config      etc.RockerMqConfig
}

func SetMqSendDataMarket(reqInfo *RequestStruct, respInfo *request.Response, url string) []byte {
	log := commonMqSendData(reqInfo, respInfo, url)
	logByte, _ := json.Marshal(log)
	return logByte
}

func SetMqSendDataZLTX(reqInfo *RequestStruct, respInfo *request.Response, url string) []byte {
	log := commonMqSendData(reqInfo, respInfo, url)
	logByte, _ := json.Marshal(log)
	return logByte
}

func SetMqSendDataRs(rsReq *RequestStruct, order *genModel.ServerOrderRs, respInfo *request.Response, url string) []byte {
	log := commonMqSendData(rsReq, respInfo, url)
	OrderMap := common.StructToMap(order)
	log = common.MergeMaps(OrderMap, log)
	logByte, _ := json.Marshal(log)
	return logByte
}

func commonMqSendData(reqInfo *RequestStruct, respInfo *request.Response, url string) map[string]interface{} {
	log := make(map[string]interface{}, 5)
	reqStr, _ := json.Marshal(reqInfo.RequestBody)
	log["data"] = string(reqStr)
	log["url"] = url
	log["resp"] = respInfo.Text
	log["code"] = respInfo.StatusCode
	log["create_time"] = time.Now().Format("2006-01-02 15:04:05")

	return log
}
