package genModel

import "github.com/zeromicro/go-zero/core/stores/sqlx"

var _ ServerMiddleMarketLogsModel = (*customServerMiddleMarketLogsModel)(nil)

type (
	// ServerMiddleMarketLogsModel is an interface to be customized, add more methods here,
	// and implement the added methods in customServerMiddleMarketLogsModel.
	ServerMiddleMarketLogsModel interface {
		serverMiddleMarketLogsModel
		withSession(session sqlx.Session) ServerMiddleMarketLogsModel
	}

	customServerMiddleMarketLogsModel struct {
		*defaultServerMiddleMarketLogsModel
	}
)

// NewServerMiddleMarketLogsModel returns a model for the database table.
func NewServerMiddleMarketLogsModel(conn sqlx.SqlConn) ServerMiddleMarketLogsModel {
	return &customServerMiddleMarketLogsModel{
		defaultServerMiddleMarketLogsModel: newServerMiddleMarketLogsModel(conn),
	}
}

func (m *customServerMiddleMarketLogsModel) withSession(session sqlx.Session) ServerMiddleMarketLogsModel {
	return NewServerMiddleMarketLogsModel(sqlx.NewSqlConnFromSession(session))
}
