package genModel

import "github.com/zeromicro/go-zero/core/stores/sqlx"

var _ ServerMiddleRsLogsModel = (*customServerMiddleRsLogsModel)(nil)

type (
	// ServerMiddleRsLogsModel is an interface to be customized, add more methods here,
	// and implement the added methods in customServerMiddleRsLogsModel.
	ServerMiddleRsLogsModel interface {
		serverMiddleRsLogsModel
		withSession(session sqlx.Session) ServerMiddleRsLogsModel
	}

	customServerMiddleRsLogsModel struct {
		*defaultServerMiddleRsLogsModel
	}
)

// NewServerMiddleRsLogsModel returns a model for the database table.
func NewServerMiddleRsLogsModel(conn sqlx.SqlConn) ServerMiddleRsLogsModel {
	return &customServerMiddleRsLogsModel{
		defaultServerMiddleRsLogsModel: newServerMiddleRsLogsModel(conn),
	}
}

func (m *customServerMiddleRsLogsModel) withSession(session sqlx.Session) ServerMiddleRsLogsModel {
	return NewServerMiddleRsLogsModel(sqlx.NewSqlConnFromSession(session))
}
