package genModel

import "github.com/zeromicro/go-zero/core/stores/sqlx"

var _ ServerOrderZltxModel = (*customServerOrderZltxModel)(nil)

type (
	// ServerOrderZltxModel is an interface to be customized, add more methods here,
	// and implement the added methods in customServerOrderZltxModel.
	ServerOrderZltxModel interface {
		serverOrderZltxModel
		withSession(session sqlx.Session) ServerOrderZltxModel
	}

	customServerOrderZltxModel struct {
		*defaultServerOrderZltxModel
	}
)

// NewServerOrderZltxModel returns a model for the database table.
func NewServerOrderZltxModel(conn sqlx.SqlConn) ServerOrderZltxModel {
	return &customServerOrderZltxModel{
		defaultServerOrderZltxModel: newServerOrderZltxModel(conn),
	}
}

func (m *customServerOrderZltxModel) withSession(session sqlx.Session) ServerOrderZltxModel {
	return NewServerOrderZltxModel(sqlx.NewSqlConnFromSession(session))
}
